      REM ====================================================================
      REM                 H I M E W o r k b e n c h . b a s
      REM    This is a 'workbench', a testprogram to test performance of the
      REM                         H I M E . d l l
      REM           Huge Integer Math and Encryption library dll
      REM                             V 2.05
      REM                    (C) 2002-2008 DevOTechS
      REM                 e-mail: support@devotechs.com
      REM
      REM Translation into 'BBC BASIC for Windows' of the PowerBasic version
      REM by Richard Russell, http://www.rtrussell.co.uk, 30th September 2012
      REM ====================================================================
      REM!Resource @dir$+"himeworkbenchbbc.res"
      
      SYS "SetWindowText", @hwnd%, "HIME (Huge Integer Math and Encryption) library - " + \
      \                            "Workbench V2.05 (BBC BASIC version)"
      
      INSTALL @lib$+"HIMELIB"
      INSTALL @lib$+"WINLIB2"
      INSTALL @lib$+"WINLIB5"
      
      REM!WC Windows constants:
      BS_DEFPUSHBUTTON = 1
      ES_AUTOHSCROLL = &80
      ES_AUTOVSCROLL = 64
      ES_MULTILINE = 4
      IDCANCEL = 2
      LB_ADDSTRING = 384
      LB_GETCURSEL = 392
      LB_GETTEXT = 393
      LB_GETTEXTLEN = 394
      LBN_SELCHANGE = 1
      LBS_SORT = 2
      MB_ICONINFORMATION = 64
      SS_CENTER = 1
      SS_RIGHT = 2
      SS_SUNKEN = 4096
      SW_HIDE = 0
      SW_SHOW = 5
      SW_SHOWNORMAL = 1
      WM_SETFONT = 48
      WS_CHILD = &40000000
      WS_DLGFRAME = &400000
      WS_EX_CLIENTEDGE = 512
      WS_GROUP = &20000
      WS_POPUP = &80000000
      WS_TABSTOP = 65536
      WS_VSCROLL = &200000
      
      REM Control IDs:
      IDC_LISTBOX1       = FN_setproc(PROC_NewListboxItemSelected())
      IDC_LABEL2         = 1003
      IDC_PARAMA         = 1004
      IDC_LABEL3         = 1005
      IDC_PARAMB         = 1006
      IDC_LABEL4         = 1007
      IDC_PARAMC         = 1008
      IDC_RESULT         = 1009
      IDC_LABEL5         = 1010
      IDC_LABEL6         = 1011
      IDC_FILLRANDOM     = FN_setproc(PROC_FillParamsWithRandoms)
      IDC_LABEL7         = 1013
      IDC_BITLENGTH      = 1014
      IDC_FRAME1         = 1015
      IDC_CLEARPARAMS    = FN_setproc(PROC_ClearParams)
      IDC_CALCTIME       = 1017
      IDC_FRAME2         = 1018
      IDC_CALCULATE      = FN_setproc(PROC_Calculate)
      IDC_EXIT           = FN_setproc(PROC_Exit)
      IDC_LABEL1         = 1021
      IDC_CALCULATINGLBL2= 1022
      IDC_CLEARRESULT    = FN_setproc(PROC_ClearResult)
      IDC_GOWEBSITE      = FN_setproc(PROC_GoWebsite)
      IDC_RADIO_HEX      = FN_setproc(PROC_Radio_Hex)
      IDC_RADIO_DEC      = FN_setproc(PROC_Radio_Dec)
      
      IDC_INPUTPROMPT    = 2000
      IDC_INPUTRESULT    = 2001
      IDC_INPUTOK        = FN_setproc(PROC_Input_OK)
      
      REM Numeric constants (for ease of passing by reference):
      Zero% = 0 : One% = 1 : Two% = 2 : Three% = 3 : Four% = 4 : Five% = 5 : Six% = 6
      Seven% = 7 : Eight% = 8 : Nine% = 9 : Ten% = 10 : Eleven% = 11 : Twelve% = 12
      Thirteen% = 13 : Fourteen% = 14 : Fifteen% = 15 : Fifty% = 50 : Thousand% = 1000
      
      REM Define dialogue box templates:
      Box% = FN_newdialog("HIME Workbench (BBC)", 150, 90, 160, 91, 8, 242)
      PROC_pushbutton(Box%, "OK", IDC_INPUTOK, 17, 69, 56, 14, BS_DEFPUSHBUTTON)
      PROC_pushbutton(Box%, "Cancel", IDCANCEL, 84, 69, 56, 14, 0)
      PROC_static(Box%, "", IDC_INPUTPROMPT, 10, 14, 140, 32, SS_CENTER)
      PROC_editbox(Box%, "", IDC_INPUTRESULT, 7, 47, 144, 14, ES_AUTOHSCROLL)
      
      Dlg% = FN_newdialog("", 0, 0, 464, 278, 8, 2000)
      Dlg%!16 = (Dlg%!16 OR WS_CHILD) AND NOT (WS_POPUP OR WS_DLGFRAME)
      PROC_static(Dlg%, "Choose an operation, enter parameters and " + \
      \       "hit 'calculate' button", IDC_LABEL1, 2, 4, 458, 18, SS_CENTER OR SS_SUNKEN)
      PROC_static(Dlg%, "Operation", IDC_LABEL2, 4, 36, 62, 10, SS_SUNKEN)
      PROC_listbox(Dlg%, "", IDC_LISTBOX1, 2, 48, 104, 226, -LBS_SORT)
      PROC_static(Dlg%, "Parameter 'a'", IDC_LABEL3, 110, 36, 68, 11, SS_SUNKEN)
      PROC_editbox(Dlg%, "0", IDC_PARAMA, 110, 48, 232, 36, WS_TABSTOP OR ES_MULTILINE OR \
      \            WS_VSCROLL OR ES_AUTOVSCROLL OR WS_EX_CLIENTEDGE)
      PROC_static(Dlg%, "Parameter 'b'", IDC_LABEL4, 110, 92, 68, 11, SS_SUNKEN)
      PROC_editbox(Dlg%, "0", IDC_PARAMB, 110, 104, 232, 36, WS_TABSTOP OR ES_MULTILINE OR \
      \            WS_VSCROLL OR ES_AUTOVSCROLL OR WS_EX_CLIENTEDGE)
      PROC_static(Dlg%, "Parameter 'c'", IDC_LABEL5, 110, 148, 68, 11, SS_SUNKEN)
      PROC_editbox(Dlg%, "0", IDC_PARAMC, 110, 160, 232, 36, WS_TABSTOP OR ES_MULTILINE OR \
      \            WS_VSCROLL OR ES_AUTOVSCROLL OR WS_EX_CLIENTEDGE)
      PROC_static(Dlg%, "Result", IDC_LABEL6, 110, 204, 204, 11, SS_SUNKEN)
      PROC_editbox(Dlg%, "", IDC_RESULT, 110, 216, 232, 56, WS_TABSTOP OR ES_MULTILINE OR \
      \            WS_VSCROLL OR ES_AUTOVSCROLL OR WS_EX_CLIENTEDGE)
      PROC_static(Dlg%, "Bitlength:", IDC_LABEL7, 356, 48, 52, 10, SS_RIGHT)
      PROC_groupbox(Dlg%, "Modify parameters", IDC_FRAME1, 348, 36, 110, 58, 0)
      PROC_editbox(Dlg%, "120", IDC_BITLENGTH, 410, 46, 36, 12, 0)
      PROC_pushbutton(Dlg%, "&Random parameters", IDC_FILLRANDOM, 362, 60, 84, 14, 0)
      PROC_pushbutton(Dlg%, "Clear &parameters", IDC_CLEARPARAMS, 362, 76, 84, 14, 0)
      PROC_groupbox(Dlg%, "Calculation time", IDC_FRAME2, 348, 100, 110, 22, 0)
      PROC_static(Dlg%, "1000 seconds", IDC_CALCTIME, 360, 110, 94, 10, 0)
      PROC_pushbutton(Dlg%, "&Calculate", IDC_CALCULATE, 362, 132, 84, 14, 0)
      PROC_static(Dlg%, "", IDC_CALCULATINGLBL2, 352, 152, 106, 16, SS_CENTER)
      PROC_pushbutton(Dlg%, "Open HIME website", IDC_GOWEBSITE, 362, 222, 84, 14, 0)
      PROC_pushbutton(Dlg%, "Clear result", IDC_CLEARRESULT, 362, 240, 84, 14, 0)
      PROC_pushbutton(Dlg%, "&Exit", IDC_EXIT, 362, 258, 84, 14, 0)
      PROC_groupbox(Dlg%, "Show numbers in:", IDC_FRAME2, 348, 170, 110, 42, 0)
      PROC_radiobutton(Dlg%, "Hexadecimal system", IDC_RADIO_HEX, 362, 180, 84, 14, WS_GROUP)
      PROC_radiobutton(Dlg%, "Decimal system", IDC_RADIO_DEC, 362, 192, 84, 14, 0)
      
      ON ERROR SYS "MessageBox", @hwnd%, REPORT$, 0, 0 : PROC_closedialog(Dlg%) : QUIT
      ON CLOSE PROC_closedialog(Dlg%) : QUIT
      
      REM Display dialogue and dock it to the main window:
      PROC_showdialog(Dlg%)
      DIM rc{l%,t%,r%,b%}
      SYS "GetWindowRect", !Dlg%, rc{}
      SYS "GetWindowLong", @hwnd%, -16 TO style%
      SYS "SetWindowLong", @hwnd%, -16, style% AND NOT &50000
      SYS "AdjustWindowRect", rc{}, style% AND NOT &50000, 0
      SYS "SetWindowPos", @hwnd%, 0, 0, 0, rc.r%-rc.l%, rc.b%-rc.t%, 102
      
      REM Initialise dialogue controls:
      CRLF$ = CHR$13 + CHR$10
      SYS "SendDlgItemMessage", !Dlg%, IDC_CALCULATINGLBL2, WM_SETFONT, @vdu.hf%, 0
      
      Mess$ =  "NOTE: This workbench program has NOT all HIME functions implemented." + CRLF$
      Mess$ += "HIME Workbench was intended to let you discover and test SOME of HIME's functions and routines." + CRLF$
      Mess$ += "Read the HIME help file for an overview of all the HIME functions." + CRLF$
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, Mess$
      SYS "CheckRadioButton", !Dlg%, IDC_RADIO_DEC, IDC_RADIO_HEX, IDC_RADIO_HEX
      Current_Number_System$ = "hex"
      
      NrOperations% = 30
      DIM Operations$(NrOperations%)
      
      Operations$(1 ) = "a + b"
      Operations$(2 ) = "a - b"
      Operations$(3 ) = "a * b"
      Operations$(4 ) = "a * a"
      Operations$(5 ) = "a * 2"
      Operations$(6 ) = "a \ b"
      Operations$(7 ) = "a \ 2"
      Operations$(8 ) = "a ^ b"
      Operations$(9 ) = "a mod b"
      Operations$(10) = "a ^ b mod c"
      Operations$(11) = "a ^ -1 mod b"
      Operations$(12) = "GCD a, b"
      Operations$(13) = "Generate prime number"
      Operations$(14) = "Generate random number"
      Operations$(15) = "Generate RSA random number"
      Operations$(16) = "Generate BBS random number"
      Operations$(17) = "Generate RSA public key"
      Operations$(18) = "RSA encrypt/decrypt data"
      Operations$(19) = "AES encrypt/decrypt data"
      Operations$(20) = "SHA-256 hash algorithm"
      Operations$(21) = "Diffie-Hellman algorithm"
      Operations$(22) = "--------------------"
      Operations$(23) = "a = 0?"
      Operations$(24) = "a < b?"
      Operations$(25) = "a is odd?"
      Operations$(26) = "a is prime? (Div. lower primes)"
      Operations$(27) = "a is prime? (Slow, 100%)"
      Operations$(28) = "a is prime? (Fermat, <>100%)"
      Operations$(29) = "a is prime? (Rabin-Miller, <>100%)"
      Operations$(30) = "a, b relative primes?"
      
      FOR N% = 1 TO NrOperations%
        SYS "SendDlgItemMessage", !Dlg%, IDC_LISTBOX1, LB_ADDSTRING, 0, Operations$(N%)
      NEXT
      
      REM Initialise HIME:
      RSA_hn$ = ""
      
      keyfile% = OPENIN(@lib$+"himekey.txt")
      IF keyfile% key$ = GET$#keyfile% : CLOSE #keyfile% ELSE key$ = ""
      PROC_himeinit(key$) : REM Licence key to suppress nag dialogue
      SYS `hi_ReadPrimes`, ^Thousand%
      
      REM Wait for user input:
      REPEAT
        WAIT 1
      UNTIL FALSE
      END
      
      REM --------------------------------------------------------------------------------
      REM Convert huge integer number to the selected number system
      DEF PROC_Huge2xxx(Reg1%, Reg2%)
      IF Current_Number_System$ = "hex" THEN
        SYS `hi_Huge2Hex`, ^Reg1%, ^Reg2%
        SYS `hi_TrimLZeroes`, ^Reg2%, ^Reg2%
      ELSE
        SYS `hi_Huge2Dec`, ^Reg1%, ^Reg2%
      ENDIF
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Convert number from the selected number system to huge integer number
      DEF PROC_xxx2Huge(Reg1%, Reg2%)
      IF Current_Number_System$ = "hex" THEN
        SYS `hi_Hex2Huge`, ^Reg1%, ^Reg2%
      ELSE
        SYS `hi_Dec2Huge`, ^Reg1%, ^Reg2%
      ENDIF
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Fill 3 parameters with a random number. The max. length of the random number is defined
      REM in the 'Bitlength' textbox
      DEF PROC_FillParamsWithRandoms
      LOCAL bitlen%, a$
      
      a$ = FNgetdlgitemtext(Dlg%, IDC_BITLENGTH)
      bitlen% = VAL(a$)
      
      SYS `hi_GenerateRandom`, ^bitlen%, ^One%
      PROC_Huge2xxx(1,1)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, FN_higet(1)
      
      SYS `hi_GenerateRandom`, ^bitlen%, ^One%
      PROC_Huge2xxx(1,1)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, FN_higet(1)
      
      SYS `hi_GenerateRandom`, ^bitlen%, ^One%
      PROC_Huge2xxx(1,1)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, FN_higet(1)
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Clear 3 parameters.
      DEF PROC_ClearParams
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, ""
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, ""
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, ""
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Hide 2nd edit control
      DEF PROC_Hide2ndEditControl
      LOCAL H%
      SYS "GetDlgItem", !Dlg%, IDC_PARAMB TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_LABEL4 TO H% : SYS "ShowWindow", H%, SW_HIDE
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Hide 3rd edit control
      DEF PROC_Hide3rdEditControl
      LOCAL H%
      SYS "GetDlgItem", !Dlg%, IDC_PARAMC TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_LABEL5 TO H% : SYS "ShowWindow", H%, SW_HIDE
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Hide 2nd and 3rd edit control
      DEF PROC_Hide2nd3rdEditControl
      PROC_Hide2ndEditControl
      PROC_Hide3rdEditControl
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Hide all edit controls
      DEF PROC_HideAllEditControls
      LOCAL H%
      SYS "GetDlgItem", !Dlg%, IDC_PARAMA TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_LABEL3 TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_PARAMB TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_LABEL4 TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_PARAMC TO H% : SYS "ShowWindow", H%, SW_HIDE
      SYS "GetDlgItem", !Dlg%, IDC_LABEL5 TO H% : SYS "ShowWindow", H%, SW_HIDE
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Show all edit controls
      DEF PROC_ShowAllEditControls
      LOCAL H%
      SYS "GetDlgItem", !Dlg%, IDC_PARAMA TO H% : SYS "ShowWindow", H%, SW_SHOW
      SYS "GetDlgItem", !Dlg%, IDC_LABEL3 TO H% : SYS "ShowWindow", H%, SW_SHOW
      SYS "GetDlgItem", !Dlg%, IDC_PARAMB TO H% : SYS "ShowWindow", H%, SW_SHOW
      SYS "GetDlgItem", !Dlg%, IDC_LABEL4 TO H% : SYS "ShowWindow", H%, SW_SHOW
      SYS "GetDlgItem", !Dlg%, IDC_PARAMC TO H% : SYS "ShowWindow", H%, SW_SHOW
      SYS "GetDlgItem", !Dlg%, IDC_LABEL5 TO H% : SYS "ShowWindow", H%, SW_SHOW
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM New listboxitem (operation) selected. Adjust display
      DEF PROC_NewListboxItemSelected(wparam%, lparam%)
      LOCAL a$
      
      IF (wparam% >>> 16) <> LBN_SELCHANGE THEN ENDPROC
      
      REM Show all editboxes
      PROC_ShowAllEditControls
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL3, "Parameter 'a'"
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL4, "Parameter 'b'"
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL5, "Parameter 'c'"
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      
      a$ = FNgetlistboxtext(Dlg%, IDC_LISTBOX1)
      CASE a$ OF
        WHEN "a + b"
          PROC_Hide3rdEditControl
          
        WHEN "a - b"
          PROC_Hide3rdEditControl
          
        WHEN "a * b"
          PROC_Hide3rdEditControl
          
        WHEN "a * a"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a * 2"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a \ b"
          
        WHEN "a \ 2"
          PROC_Hide2ndEditControl
          
        WHEN "a ^ b"
          PROC_Hide3rdEditControl
          
        WHEN "a mod b"
          PROC_Hide3rdEditControl
          
        WHEN "a ^ b mod c"
          
        WHEN "a ^ -1 mod b"
          PROC_Hide3rdEditControl
          
        WHEN "GCD a, b"
          PROC_Hide3rdEditControl
          
        WHEN "Generate prime number"
          PROC_HideAllEditControls
          
        WHEN "Generate random number"
          PROC_HideAllEditControls
          
        WHEN "Generate RSA random number"
          PROC_HideAllEditControls
          
        WHEN "Generate BBS random number"
          PROC_HideAllEditControls
          
        WHEN "Generate RSA public key"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL3, "Modulus n"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL4, "Public key e"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL5, "Private key d"
          PROC_ClearParams
          
        WHEN "RSA encrypt/decrypt data", "AES encrypt/decrypt data"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL3, "Plaintext"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL4, "Encrypted text"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL5, "Decrypted text"
          PROC_ClearParams
          
        WHEN "SHA-256 hash algorithm"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL3, "Text"
          SYS "SetDlgItemText", !Dlg%, IDC_LABEL4, "Hash value"
          REM SYS "SetDlgItemText", !Dlg%, IDC_LABEL5, "Decrypted text"
          PROC_ClearParams
          PROC_Hide3rdEditControl
          
        WHEN "Diffie-Hellman algorithm"
          PROC_HideAllEditControls
          
        WHEN "a = 0?"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a < b?"
          PROC_Hide3rdEditControl
          
        WHEN "a is odd?"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a is prime? (Div. lower primes)"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a is prime? (Slow, 100%)"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a is prime? (Fermat, <>100%)"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a is prime? (Rabin-Miller, <>100%)"
          PROC_Hide2nd3rdEditControl
          
        WHEN "a, b relative primes?"
          PROC_Hide3rdEditControl
          
      ENDCASE
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM Perform selected calculation
      DEF PROC_Calculate
      LOCAL a$, i%, ParamA$, ParamB$, ParamC$, Result%, StartTime%, Bits%, Tests%
      LOCAL Bytes%, ModBits%, Length%, res%
      
      REM Get selected operation
      a$ = FNgetlistboxtext(Dlg%, IDC_LISTBOX1)
      IF a$ = "" THEN
        PROCmsgbox("Select an operation first...")
        ENDPROC
      ENDIF
      
      REM Get parameters from textboxes (as ascii strings)
      ParamA$ = FNgetdlgitemtext(Dlg%, IDC_PARAMA)
      ParamB$ = FNgetdlgitemtext(Dlg%, IDC_PARAMB)
      ParamC$ = FNgetdlgitemtext(Dlg%, IDC_PARAMC)
      
      REM Store in registers and convert to binary
      PROC_hiput(1, ParamA$)
      PROC_xxx2Huge(1,1)
      
      PROC_hiput(2, ParamB$)
      PROC_xxx2Huge(2,2)
      
      PROC_hiput(3, ParamC$)
      PROC_xxx2Huge(3,3)
      
      REM Perform operation
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL6, ""
      SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, "Calculating..."
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      
      StartTime% = TIME
      CASE a$ OF
        WHEN "a + b"
          SYS `hi_Add`, ^One%, ^Two%, ^Nine%
          
        WHEN "a - b"
          SYS `hi_IsLess`, ^One%, ^Two% TO res%
          IF res% THEN
            PROCmsgbox("a < b. Result will be negative (sign not shown)...")
          ENDIF
          SYS `hi_Sub`, ^One%, ^Two%, ^Nine%
          
        WHEN "a * b"
          SYS `hi_Mul`, ^One%, ^Two%, ^Nine%
          
        WHEN "a * a"
          SYS `hi_Square`, ^One%, ^Nine%
          
        WHEN "a * 2"
          SYS `hi_MulBy2`, ^One%, ^Nine%
          
        WHEN "a \ b"
          SYS `hi_IsZero`, ^Two% TO res%
          IF res% THEN
            PROCmsgbox("Division by zero!")
          ELSE
            SYS `hi_Div`, ^One%, ^Two%, ^Nine%, ^Four%
            REM Already show Remainder:
            PROC_Huge2xxx(4,4)
            ParamC$ = FN_higet(4)
            SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, "Remainder: " + ParamC$
          ENDIF
          
        WHEN "a \ 2"
          SYS `hi_DivBy2`, ^One%, ^Nine%, ^Eight%
          REM Already show remainder:
          PROC_Huge2xxx(8,8)
          ParamC$ = FN_higet(8)
          SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, "Remainder: " + ParamC$
          
        WHEN "a ^ b"
          SYS `hi_Pow`, ^One%, ^Two%, ^Nine%
          
        WHEN "a mod b"
          SYS `hi_Mod`, ^One%, ^Two%, ^Nine%
          
        WHEN "a ^ b mod c"
          SYS `hi_IsZero`, ^Three% TO res%
          IF res% THEN
            PROCmsgbox("C parameter must not be zero!")
            SYS `hi_RegClear`, ^Nine%
          ELSE
            SYS `hi_PowMod`, ^One%, ^Two%, ^Three%, ^Nine%
          ENDIF
          
        WHEN "a ^ -1 mod b"
          SYS `hi_ModInv`, ^One%, ^Two%, ^Nine% TO i%
          IF i% = 1 THEN
            a$ = "No result: GCD(a,b) <> 1 !"
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, a$
            SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
            ENDPROC
          ENDIF
          
        WHEN "GCD a, b"
          SYS `hi_GCD`, ^One%, ^Two%, ^Nine%
          
        WHEN "Generate prime number"
          a$ = "Enter the length of the prime number to be generated (in bytes)"
          Bits% = 8 * VAL(FNinputbox(a$, "100"))
          IF Bits%=0 ENDPROC
          a$ = "Number of tests to be performed by Rabin-Miller test [2-15]"
          Tests% = VAL(FNinputbox(a$, "5"))
          IF Tests%=0 ENDPROC
          StartTime% = TIME
          SYS `hi_GeneratePrime`, ^Bits%, ^Tests%, ^Nine%
          
        WHEN "Generate random number"
          a$ = "Enter the length of the random number to be generated (in bytes)"
          Bits% = 8 * VAL(FNinputbox(a$, "100"))
          IF Bits%=0 ENDPROC
          StartTime% = TIME
          SYS `hi_GenerateRandom`, ^Bits%, ^Nine%
          
        WHEN "Generate RSA random number"
          a$ = "Enter the length of the random number to be generated (in bytes)"
          Bytes% = VAL(FNinputbox(a$, "100"))
          IF Bytes%=0 ENDPROC
          a$ = "Enter the length of the RSA modulus (in bits)"
          ModBits% = VAL(FNinputbox(a$, "128"))
          IF ModBits%=0 ENDPROC
          a$ = "Initializing RSA generator. Only needed once..."
          SYS "SetDlgItemText", !Dlg%, IDC_RESULT, a$
          
          SYS `hi_GenerateRSAKeys`, ^ModBits%, ^Three%, ^One%, ^Two%, ^Three% : REM he, hd, hn
          ModBits% -= 8
          SYS `hi_GenerateRandom`, ^ModBits%, ^Four% : REM Generate seed
          StartTime% = TIME
          SYS `hi_GenerateRSARandomBits`, ^Bytes%, ^Four%, ^One%, ^Three%, ^Nine%, ^Four%
          
        WHEN "Generate BBS random number"
          a$ = "Enter the length of the random number to be generated (in bytes)"
          Bytes% = VAL(FNinputbox(a$, "100"))
          IF Bytes%=0 ENDPROC
          a$ = "Enter the length of the BBS modulus (in bits)"
          ModBits% = VAL(FNinputbox(a$, "128"))
          IF ModBits%=0 ENDPROC
          a$ = "Initializing BBS generator. Only needed once..."
          SYS "SetDlgItemText", !Dlg%, IDC_RESULT, a$
          SYS `hi_InitBBS`, ^ModBits%, ^Four%, ^One%, ^Two% : REM bitlength, primetests, modulus, seed
          
          StartTime% = TIME
          SYS `hi_GenerateBBSRandomBits`, ^Bytes%, ^One%, ^Two%, ^One%, ^Nine%, ^Two% REM Bytes, MultipleBits, New seed, modulus, result, old seed
          
        WHEN "Generate RSA public key"
          REM PROC_GenerateRSAkey : REM Use original RSA
          PROC_GenerateRSA_CRTkey : REM Use RSA-CRT
          
        WHEN "RSA encrypt/decrypt data"
          PROC_RSA_Encrypt_Decrypt
          
        WHEN "AES encrypt/decrypt data"
          PROC_AES_Encrypt_Decrypt
          
        WHEN "SHA-256 hash algorithm"
          REM Store Parameter A in register 1
          PROC_hiput(1, ParamA$)
          
          REM Calculate its hash value
          SYS `hi_Hash_SHA_256`, ^One%, ^Two% : REM Register 2 contains hash value
          SYS `hi_RegReverse`, ^Two%, ^Two% : REM Reverse hash value because Huge2xxx changes endian
          PROC_Huge2xxx(2, 3) : REM Convert hash value to hex
          SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, FN_higet(3)
          SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
          ENDPROC
          
        WHEN "Diffie-Hellman algorithm"
          PROC_DiffieHellmanAlgo
          
        WHEN "a = 0?"
          SYS `hi_IsZero`, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a = 0"
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a <> 0"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a < b?"
          SYS `hi_IsLess`, ^One%, ^Two% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a < b"
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a >= b"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a is odd?"
          SYS `hi_IsOdd`, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is odd"
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is even"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a is prime? (Div. lower primes)"
          SYS  `hi_IsPrime_Div`, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is possibly a prime.."
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is definitely NOT prime"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a is prime? (Slow, 100%)"
          SYS `hi_IsPrime_Slow`, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is definitely a prime.."
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is definitely NOT prime"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a is prime? (Fermat, <>100%)"
          a$ = "Number of tests to be performed by Fermat test [1-100]"
          Tests% = VAL(FNinputbox(a$, "5"))
          IF Tests%=0 ENDPROC
          SYS `hi_IsPrime_F`, ^Tests%, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is possibly a prime.."
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is definitely NOT prime"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a is prime? (Rabin-Miller, <>100%)"
          a$ = "Number of tests to be performed by Rabin-Miller test [1-100]"
          Tests% = VAL(FNinputbox(a$, "5"))
          IF Tests%=0 ENDPROC
          SYS `hi_IsPrime_RB`, ^Tests%, ^One% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is possibly a prime.."
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a is definitely NOT prime"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        WHEN "a, b relative primes?"
          SYS `hi_IsRelPrime`, ^One%, ^Two% TO res%
          IF res% THEN
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a and b are relative primes"
          ELSE
            SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "a and b are NOT relative primes"
          ENDIF
          PROC_DisplayFalseTrue
          ENDPROC
          
        OTHERWISE:
          SYS "MessageBox", @hwnd%, "Unknown operation..", 0, 0
          
      ENDCASE
      REM Display calculation time
      SYS "SetDlgItemText", !Dlg%, IDC_CALCTIME, STR$((TIME - StartTime%)/100) + " seconds"
      REM Display result
      SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, "Preparing result"
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, "Preparing result to display. May take a while..."
      REM Convert binary result to decimal
      SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
      PROC_Huge2xxx(9,9)
      SYS `hi_GetRegAsciiz1`, ^Nine% TO Result%
      SYS `hi_RegGetLen`, ^Nine% TO Length%
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, Result%
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL6, "Result (" + STR$(Length%) + " digits)"
      
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_DisplayFalseTrue
      REM Display calculation time
      SYS "SetDlgItemText", !Dlg%, IDC_CALCTIME, STR$((TIME - StartTime%)/100) + " seconds"
      SYS "SetDlgItemText", !Dlg%, IDC_LABEL6, "Result"
      SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_GenerateRSAkey
      LOCAL ModBits%, a$
      
      a$ = "Enter the length of the RSA modulus (in bits)"
      ModBits% = VAL(FNinputbox(a$, "256"))
      IF ModBits%=0 ENDPROC
      StartTime% = TIME
      
      PROC_hiputdec(1, "65537") : REM Preset he with a value
      SYS `hi_GenerateRSAKeys`, ^ModBits%, ^Four%, ^One%, ^Two%, ^Three% : REM Bitlength, Primetests, he, hd, hn
      
      RSA_hn$ = FN_higet(3)
      PROC_Huge2xxx(3, 4)
      a$ = FN_higet(4)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, a$
      
      RSA_he$ = FN_higet(1)
      PROC_Huge2xxx(1, 4)
      a$ = FN_higet(4)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, a$
      
      RSA_hd$ = FN_higet(2)
      PROC_Huge2xxx(2, 4)
      a$ = FN_higet(4)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, a$
      SYS `hi_RegClear`, ^Nine% : REM Clear result register
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_GenerateRSA_CRTkey
      LOCAL ModBits%, a$
      
      a$ = "Enter the length of the RSA modulus (in bits)"
      ModBits% = VAL(FNinputbox(a$, "256"))
      IF ModBits%=0 ENDPROC
      StartTime% = TIME
      
      PROC_hiputdec(1, "65537") : REM Preset he with a value
      REM hi_GenerateRSAKeys_CRT (lBitLength, lPrimeTests, lReg_he, lReg_Modul, lReg_hp, lReg_hq, lReg_hdp, lReg_hdq, lReg_hPInvQ)
      SYS `hi_GenerateRSAKeys_CRT`, ^ModBits%, ^Four%,  ^One%,^Three%, \
      \                             ^Ten%,^Eleven%,^Twelve%,^Thirteen%,^Fourteen%
      
      RSA_hn$ = FN_higet(3)
      PROC_Huge2xxx(3, 4)
      a$ = FN_higet(4)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, a$
      
      RSA_he$ = FN_higet(1)
      PROC_Huge2xxx(1, 4)
      a$ = FN_higet(4)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, a$
      
      RSA_hp$     = FN_higet(10)
      RSA_hq$     = FN_higet(11)
      RSA_hdp$    = FN_higet(12)
      RSA_hdq$    = FN_higet(13)
      RSA_hPInvQ$ = FN_higet(14)
      
      a$ = "Private key parameters not shown"
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, a$
      SYS `hi_RegClear`, ^Nine% : REM Clear result register
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_DiffieHellmanAlgo
      LOCAL DH_Bitlength%, a$, i%, res%
      REM Diffie-Hellman algorithm
      
      REM Show some info for the user
      a$ =  "Diffie-Hellman algorithm" + CRLF$
      a$ += "---------------------------" + CRLF$
      a$ += "We are going to exchange some NON-SECRET data with another party, called Bob." + CRLF$
      a$ += "After the procedure, both parties will possess a common secret number." + CRLF$
      a$ += CRLF$
      a$ += "First, 2 parameters P and G are generated. You must enter the required bitlength for P." + CRLF$ + CRLF$
      a$ += "Depending on the bitlength, calculation may take some time..." + CRLF$
      a$ += "So, do not get worried when you don't see a message appear on your screen immediately.."
      PROCmsgbox(a$)
      
      REM 1)Calculate parameters P and G:
      a$ =     "Enter the bitlength of the parameter P." + CRLF$
      DH_Bitlength% = VAL(FNinputbox(a$, "256")) : REM Bitlength of parameter P
      IF DH_Bitlength%=0 ENDPROC
      SYS `hi_DH_GenParams`, ^DH_Bitlength%, ^One%, ^Two% : REM (lBitLength%, lRegP%, lRegG%)
      
      PROC_Huge2xxx(1, 8) : REM Convert P to decimal
      SYS `hi_BreakString`, ^Eight%, ^Fifty%, ^Zero%, ^One%, ^Eight%
      PROC_Huge2xxx(2, 9) : REM Convert G to decimal
      SYS `hi_BreakString`, ^Nine%, ^Fifty%, ^Zero%, ^One%, ^Nine%
      
      a$ =  "Parameter P:" + CRLF$
      a$ += FN_higet(8) + CRLF$ + CRLF$
      a$ += "Parameter G:" + CRLF$
      a$ += FN_higet(9) + CRLF$ + CRLF$
      
      a$ += "These parameters P and G must be sent to Bob." + CRLF$
      a$ += "He must use the same parameters. Once we have agreed on using these" + CRLF$
      a$ += "parameters, we can reuse them the next time." + CRLF$
      a$ += " " + CRLF$
      a$ += "We must now choose a private key for ourselves. This key must be kept secret!" + CRLF$
      a$ += "With this private key and parameters P and G, we will calculate our public key." + CRLF$
      PROCmsgbox(a$)
      
      REM 2) First, we must choose a private key for ourselves
      
      REM 2a) Choose a private key (0 < PrivKey < P-1) and keep it secret!
      REM Store our private key in register 3
      REPEAT
        a$ =  "Enter a private key. It must be a number larger than 0" + CRLF$
        a$ += "and smaller than P - 1"
        a$ = FNinputbox(a$, "1000")
        PROC_hiput(3, a$)
        PROC_xxx2Huge(3, 3)
        
        REM 2b) Calculate our public key and store in register 4
        SYS `hi_DH_Step1`, ^One%, ^Two%, ^Three%, ^Four% TO i% : REM (lRegP%, lRegG%, lPriv%, lPub%)
        IF i% <> 0 THEN
          a$ = "The private key you entered was out of range." + CRLF$
          PROCmsgbox(a$)
        ENDIF
      UNTIL i% = 0
      
      REM 3) Next let's pretend that we are Bob:
      REM 3a) Make up a private key (0 < PrivKey < P-1) and keep it secret!
      DH_Bitlength% -= 8
      SYS `hi_GenerateRandom`, ^DH_Bitlength%, ^Thirteen% : REM Store Bobs private key in register 13
      REM 3b) Calculate a public key for Bob and store in register 14
      SYS `hi_DH_Step1`, ^One%, ^Two%, ^Thirteen%, ^Fourteen% TO i% : REM (lRegP%, lRegG%, lPriv%, lPub%)
      IF i% <> 0 THEN
        REM         PrintData "Bob: Illegal input parameter"
      ENDIF
      
      REM 4) We send our public key to Bob and Bob sends his public key
      REM    to us
      
      REM 5) We calculate our shared key, using our own private key and Bobs public key
      REM    Our shared key is in register 5
      SYS `hi_DH_Step2`, ^One%, ^Fourteen%, ^Three%, ^Five% TO i% : REM (lRegP%, lPub%, lPriv%, lShared%)
      IF i% <> 0 THEN
        REM         PrintData "Calculating our shared key: Illegal input parameter"
      ENDIF
      
      REM 6) Bob calculates his shared key, using his own private key and our public key
      REM    Bobs shared key is in register 15
      SYS `hi_DH_Step2`, ^One%, ^Four%, ^Thirteen%, ^Fifteen% TO i% : REM (lRegP%, lPub%, lPriv%, lShared%)
      IF i% <> 0 THEN
        REM         PrintData "Calculating Bobs shared key: Illegal input parameter"
      ENDIF
      a$ =  "We have sent our public key to Bob." + CRLF$
      a$ += "Bob has sent his public key to us." + CRLF$ + CRLF$
      a$ += "We use that, together with our private key, to calculate the shared key." + CRLF$
      PROCmsgbox(a$)
      
      REM 7) Both our and Bobs shared key MUST be the same! Check this:
      SYS `hi_IsNotEqual`, ^Five%, ^Fifteen% TO res%
      IF res% THEN
        a$ = "Both our and Bobs shared key are not the same! " + CRLF$
        a$ += "Obviously something went wrong..." + CRLF$
        PROCmsgbox(a$)
      ENDIF
      
      PROC_Huge2xxx(5, 5) : REM Convert our key to decimal
      SYS `hi_BreakString`, ^Five%, ^Fifty%, ^Zero%, ^One%, ^Five%
      PROC_Huge2xxx(15, 15) : REM Convert Bobs key to decimal
      SYS `hi_BreakString`, ^Fifteen%, ^Fifty%, ^Zero%, ^One%, ^Fifteen%
      a$ = "Our shared key:" + CRLF$
      a$ += FN_higet(5) + CRLF$ + CRLF$
      a$ += "Bobs shared key:" + CRLF$
      a$ += FN_higet(15) + CRLF$
      PROCmsgbox(a$)
      SYS `hi_RegClear`, ^Nine% : REM clear result register
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_RSA_Encrypt_Decrypt:
      LOCAL Ciphertext$, Plaintext$, a$, res%
      REM Check if a keypair was already defined
      IF RSA_hn$ = "" THEN
        REM Keypair needs to be defined
        REM PROC_GenerateRSAkey : REM Use original RSA
        PROC_GenerateRSA_CRTkey : REM Use RSA-CRT
      ELSE
        REM PROC_hiput(1, RSA_he$) : REM For original RSA
        REM PROC_hiput(2, RSA_hd$)
        REM PROC_hiput(3, RSA_hn$)
        
        PROC_hiput(1, RSA_he$) : REM For RSA-CRT
        PROC_hiput(3, RSA_hn$)
        
        PROC_hiput(10, RSA_hp$)
        PROC_hiput(11, RSA_hq$)
        PROC_hiput(12, RSA_hdp$)
        PROC_hiput(13, RSA_hdq$)
        PROC_hiput(14, RSA_hPInvQ$)
        
      ENDIF
      a$ = "Enter a string to encrypt (max. length:" + STR$(LEN(RSA_hn$)) + " bytes)"
      a$ = FNinputbox(a$, "")
      IF a$="" ENDPROC
      REM Make plaintext length a multiple of 4
      IF LEN(a$) MOD 4 > 0 THEN
        a$ += STRING$(4 - LEN(a$) MOD 4, "-")
      ENDIF
      
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, a$
      PROC_hiput(4, a$) : REM Store plaintext in register
      REM modulus < plaintext?
      SYS `hi_IsLess`, ^Three%, ^Four% TO res%
      IF res% THEN
        PROCmsgbox("Message is too long!!")
        SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
        ENDPROC
      ENDIF
      
      StartTime% = TIME
      REM Encrypt plaintext into ciphertext
      SYS `hi_Encrypt_RSA`, ^Four%, ^One%, ^Three%, ^Five% : REM plaintext, he, hn, ciphertext
      
      Ciphertext$ = FN_higet(5)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, Ciphertext$
      
      REM Decrypt ciphertext into plaintext
      REM hi_Decrypt_RSA(5, 2, 3, 6)  'ciphertext, he, hn, plaintext   '<-- Original RSA
      REM hi_Decrypt_RSA_CRT lReg_Cipher, lReg_p, lReg_q, lReg_dp, lReg_dq, lReg_PInvQ, lReg_Plain
      SYS `hi_Decrypt_RSA_CRT`, ^Five%,  ^Ten%,^Eleven%,^Twelve%,^Thirteen%,^Fourteen%,  ^Six%
      Plaintext$ = FN_higet(6)
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, Plaintext$
      
      SYS `hi_RegClear`, ^Nine% : REM Clear result register
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF PROC_AES_Encrypt_Decrypt
      LOCAL a$, i%, res%, Passphrase$, Plaintext$
      REM Step 1: Encrypt some data ============================================
      REM Enter some plaintext
      a$ = "Enter a string (of any length) to encrypt"
      Plaintext$ = FNinputbox(a$, "")
      IF Plaintext$="" ENDPROC
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMA, Plaintext$ : REM Show plaintext in textbox
      
      REM Enter the passphrase
      a$ = "Enter a passphrase to encrypt the string"
      Passphrase$ = FNinputbox(a$, "")
      IF Passphrase$="" ENDPROC
      
      REM Calculate the SHA-256 hash value of the passphrase to
      REM use that as the key for AES encryption
      PROC_hiput(1, Passphrase$) : REM Store passphrase in register 1
      SYS `hi_Hash_SHA_256`, ^One%, ^Two% : REM Hash register 1 --> 2
      REM Register 2 now holds the AES key (32 bytes/256 bits)
      
      REM Store plaintext in register 3
      PROC_hiput(3, Plaintext$)
      
      REM Use an empty string as IV (Initial Vector) and store in register 4
      PROC_hiput(4, "")
      
      REM Encrypt plaintext
      SYS `hi_Encrypt_AES_CBC`, ^Three%, ^Two%, ^Four%, ^Five% TO i% : REM Ciphertext is in register 5
      CASE i% OF
        WHEN 1:
          PROCmsgbox("AES key is NOT equal to 16, 24 or 32 bytes")
          SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
          ENDPROC
        WHEN 2:
          PROCmsgbox("IV is not empty and not equal to blocklength (16 bytes)")
          SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
          ENDPROC
      ENDCASE
      
      REM Show ciphertext in textbox
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMB, FN_higet(5)
      
      REM Step 2: Decrypt the data ============================================
      REM Enter the passphrase
      a$ = "Enter a passphrase to decrypt the string"
      Passphrase$ = FNinputbox(a$, "")
      IF Passphrase$="" ENDPROC
      
      REM Calculate the SHA-256 hash value of the passphrase to
      REM use that as the key for AES encryption
      PROC_hiput(1, Passphrase$) : REM Store passphrase in register 1
      SYS `hi_Hash_SHA_256`, ^One%, ^Two% : REM Hash register 1 --> 2
      REM Register 2 now holds the AES key (32 bytes/256 bits)
      
      REM Decrypt ciphertext in register 5
      SYS `hi_Decrypt_AES_CBC`, ^Five%, ^Two%, ^Six% TO i% : REM Register 6 contains the decrypted ciphertext. This should
      REM equal the original plaintext
      
      CASE i% OF
        WHEN 1:
          PROCmsgbox("AES key is NOT equal to 16, 24 or 32 bytes")
          SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
          ENDPROC
        WHEN 2:
          PROCmsgbox("Ciphertext length is not a multiple of an AES block (16 bytes)")
          SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
      ENDCASE
      
      REM Show decrypted ciphertext in textbox
      SYS "SetDlgItemText", !Dlg%, IDC_PARAMC, FN_higet(6)
      
      SYS `hi_IsNotEqual`, ^Three%, ^Six% TO res%
      IF res% THEN
        PROCmsgbox("Decryption error: decrypted ciphertext does not equal original plaintext!")
      ENDIF
      
      SYS "SetDlgItemText", !Dlg%, IDC_CALCULATINGLBL2, ""
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      REM    ** CallBacks **
      REM --------------------------------------------------------------------------------
      
      DEF PROC_Radio_Hex
      Current_Number_System$ = "hex"
      PROC_ClearParams
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      ENDPROC
      
      DEF PROC_Radio_Dec
      Current_Number_System$ = "dec"
      PROC_ClearParams
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      ENDPROC
      
      DEF PROC_ClearResult
      SYS "SetDlgItemText", !Dlg%, IDC_RESULT, ""
      ENDPROC
      
      DEF PROC_GoWebsite
      SYS "ShellExecute", @hwnd%, "open", "http://www.devotechs.com/", "", "", SW_SHOWNORMAL
      ENDPROC
      
      DEF PROC_Exit
      PROC_closedialog(Dlg%)
      QUIT
      ENDPROC
      
      REM --------------------------------------------------------------------------------
      
      DEF FNgetdlgitemtext(dlg%, idc%)
      LOCAL H%, L%, T%
      SYS "GetDlgItem", !dlg%, idc% TO H%
      SYS "GetWindowTextLength", H% TO L%
      DIM T% LOCAL L%
      SYS "GetDlgItemText", !dlg%, idc%, T%, L%+1
      = $$T%
      
      DEF FNgetlistboxtext(dlg%, idc%)
      LOCAL H%, L%, S%, T%
      SYS "SendDlgItemMessage", !dlg%, idc%, LB_GETCURSEL, 0, 0 TO S%
      SYS "SendDlgItemMessage", !dlg%, idc%, LB_GETTEXTLEN, S%, 0 TO L%
      DIM T% LOCAL L%
      SYS "SendDlgItemMessage", !dlg%, idc%, LB_GETTEXT, S%, T%
      = $$T%
      
      DEF PROCmsgbox(m$)
      SYS "MessageBox", @hwnd%, m$, "HIME workbench", MB_ICONINFORMATION
      ENDPROC
      
      DEF FNinputbox(prompt$, preset$)
      LOCAL result$, sharedOK%
      PROC_showdialog(Box%)
      SYS "SetDlgItemText", !Box%, IDC_INPUTPROMPT, prompt$
      SYS "SetDlgItemText", !Box%, IDC_INPUTRESULT, preset$
      REPEAT
        WAIT 1
      UNTIL sharedOK% OR !Box%=0
      IF sharedOK% THEN result$ = FNgetdlgitemtext(Box%, IDC_INPUTRESULT)
      PROC_closedialog(Box%)
      = result$
      
      DEF PROC_Input_OK
      sharedOK% OR= TRUE
      ENDPROC
      
